<?php
namespace Plugin\Routing;

use Plugin\Exception\Error;
class Router {
	
	private static $rt;
	
	private $routes;
	private $uri;
	private $currentRoute;
	
	private static function initialize(){
		if (self::$rt){
			return ;
		}
		$rt = new self();
		
		$app = Settings::getAppsInfo();
		$routePaths = $rt->getAppPaths();
		
		$allRoutes = array();
		
		foreach ($routePaths as $path){
			$filepath = ROOT_DIR."{$path}";
			if (file_exists($filepath)){
				include($filepath); // $routes variable is in the include
				$allRoutes = array_merge($allRoutes,$route);
			}
		}
		
		if (!empty($allRoutes)){
			Error::throw500("There are no routes availabe. Go to src/{Your App}/{Section}/Config/routes.php");
		}
		
		$rt->setUri($_SERVER["REQUEST_URI"]);
		$rt->setRoutes($allRoutes);
		
		self::$rt = $rt;
	}
	
	public static function getRoute(){
		self::initialize();
		$rt = self::$rt;
		$rt->processRoute();
		return $rt->getCurrentRoute();
	}
	
	public function setUri($uri){
		$this->uri = $uri;
	}
	
	public function setRoutes($routes){
		$this->routes = $routes;
	}
	
	public function getCurrentRoute(){
		return $this->currentRoute;
	}
	
	public function processRoute(){
		// Whole router enchilada goes here
	}
	
	
	private function getAppPaths($apps){
		$path = array();
		foreach ($apps as $app => $sections) {
			foreach($sections as $name){
				$paths[] = "/src/$app/$name/Config/routes.php";
			}
		}
		return $path;
	}
}